/*
 * Collisions 5000 Info - a logic puzzle game for PalmOS devices.
 * 
 * frmIntro.c ,v 1.00 2001/05/31 
 * Copyright (C) 2001, Graham Rowbottom
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
 
#include <PalmOS.h>
#include "Collisions5000.h"
#include "Collisions5000_res.h"   
#include "Bitmap.h"   

void loadLevels(Word listID);


Boolean frmIntro_HandleEvent(EventPtr event)
{
	FormPtr form;
	Boolean handled = false;

	switch (event->eType)
	{
	
		case lstSelectEvent:
			// run the selected level
			runLevel(LEVELS_DB_NAME, LEVELS_DB_TYPE, event->data.lstSelect.selection);
			break;
			
		case frmOpenEvent:
			// Repaint form on open
			form = FrmGetActiveForm();
			FrmDrawForm(form);
			loadLevels(frmIntro_LoadList);
			handled = true;
			break;
		default:
			break;
	}

	return handled;
}

void runLevel(char * name, unsigned long type, int index)
{
	Word form  = FrmGetActiveFormID();
	DatabaseAccess_loadLevelIntoGameState(name, type, index);
	
	
	if (form != frmMain)
		FrmGotoForm(frmMain);
	else
		drawScreen();
	
	gameBullets = MemPtrNew(sizeof(bulletsType));
	nextTurnAdd = MemPtrNew(sizeof(bulletsType));
	gameBullets->numShots = 0;
	nextTurnAdd->numShots = 0;
	gameState->paused = false;
	gameState->levelFinished = false;
}

void loadLevels(Word listID)
{
	int n;
	FormPtr form = FrmGetActiveForm();
	ListPtr list = FrmGetObjectPtr(form, FrmGetObjectIndex(form, listID));
	
	// only need to do this once
	if (globalLevelsContainer == NULL)
	{	
		DatabaseAccess_getLevelnames(LEVELS_DB_NAME, LEVELS_DB_TYPE, &globalLevelsContainer, &globalLevelsNumber);
	}
	
	LstSetListChoices(list, globalLevelsContainer, globalLevelsNumber);
	LstDrawList(list);
}
